"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _path = _interopRequireDefault(require("path"));

var _stanUtils = require("stan-utils");

var _util = require("./util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

/**
 * generate reference
 * @param dts
 * @param entryFilepath
 */
function writeReference(dts, entryFilepath) {
  entryFilepath = _path.default.resolve(entryFilepath);
  var orgContent = '';

  if (_stanUtils.fs.existsSync(entryFilepath)) {
    orgContent = _stanUtils.fs.readFileSync(entryFilepath).toString();
  }

  var content = orgContent + _toConsumableArray(new Set(dts)).sort().map(function (d) {
    return "/// <reference path=\"".concat((0, _stanUtils.slash)(_path.default.relative(_path.default.parse(entryFilepath).dir, d)), "\" />");
  }).filter(function (v) {
    return !orgContent.includes(v);
  }).join('\n');

  _stanUtils.fs.outputFileSync(entryFilepath, (0, _util.formatTS)((0, _util.writeBanner)(content)));
}

var _default = writeReference;
exports.default = _default;